#include <windows.h>
#include <winioctl.h>
#include <winnt.h>
#include <stdio.h>

#define bufsize 16384

wchar_t buf[bufsize];

int main(int argc, char** argv)
{
	/*
	DWORD rc;
	wchar_t* p;
	rc = QueryDosDevice( NULL, buf, bufsize );
	if ( rc == 0 ) {
		printf("QueryDosDevice failed\n");
		return 1;
	}
	if ( rc >= bufsize - 1 ) {
		printf("buffer too small\n");
		return 1;
	}
	printf("QueryDosDevice returned %ld\n", rc);
	int i=0;
	for ( p = buf; *p != L'\0'; p += wcslen( p ) + 1 ) {
		wprintf( L"%d: %s\n", i, p);
		i++;
	}*/

	int driveno = 0;
	char filename[100];
	HANDLE h;
	DISK_GEOMETRY geometry;
	DWORD length;

	while (true) {
		sprintf(filename, "\\\\.\\PhysicalDrive%d",driveno);
		printf("checking %s: ", filename);
		fflush(stdout);
		h = CreateFile(filename, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, 0);
		if (h == INVALID_HANDLE_VALUE) {
			int err = GetLastError();
			if (err == 5) {
				printf("error - need admin privileges to access phyiscal drives!\n");
				break;
			}
			if (err == 2) {
				printf("no more drives found\n");
				break;
			}
			if (err == 0) {
				printf("not an error???\n");
				break;
			}

		} else {
			if (!DeviceIoControl(h, IOCTL_DISK_GET_DRIVE_GEOMETRY, NULL, 0,
				&geometry, sizeof(geometry), &length, NULL)) {
				printf("reading drive geometry failed\n");
			} else {
				printf("%ld/%ld/%ld C/H/S, %ldMB\n",
					(long) geometry.Cylinders.QuadPart,
					geometry.TracksPerCylinder,
					geometry.SectorsPerTrack,
					(long)((geometry.Cylinders.QuadPart * geometry.TracksPerCylinder * geometry.SectorsPerTrack 
					* geometry.BytesPerSector) / (1024*1024)));
			}
			CloseHandle(h);
		}
		driveno++;
	}

	return 0;
}
